' ***************************************************************************
'  Product Name : ft Server
'  File Name    : io_recovery.vbs
'  Create Date  : 2025/05/21
' ***************************************************************************

Option Explicit
On Error Resume Next

Dim WS2022Flag   'OSWS2022ǂ
Dim SwitchFlag   'vC}̐؂ւsǂ
Dim RegCrashDump '_v̎
Dim IO10_State   'PCIW[#10̏
Dim IO11_State   'PCIW[#11̏
Dim CurrentState
Dim CurrentCount
Dim scriptPath
Dim scriptFolder
Dim Ret
Dim objWbem

WS2022Flag = False
SwitchFlag = False
RegCrashDump = 2 'lƂāuJ[l_vv̒l

' XNvg̊SpX擾
scriptPath = WScript.ScriptFullName

' XNvg̎stH_擾
scriptFolder = Left(scriptPath, InStrRev(scriptPath, "\"))

Const SCRIPT_NAME        = "io_recovery.vbs"
Const VERSION            = "2.00"
Const WAIT_OS_START      = 300000
Const IOBoard_CLASS      = "SRA_IOBoard"
Const IO10_DevID         = "10"
Const IO11_DevID         = "11"
Const STATE_EMPTY        = &h00010000
Const STATE_NOT_PRESENT  = &h00010018
Const STATE_REMOVED      = &h00020001
Const STATE_INITIALIZING = &h00020007
Const STATE_SYNCING      = &h00020008
Const STATE_DIAGNOSTICS  = &h00040005
Const STATE_ONLINE       = &h00080014
Const STATE_SIMPLEX      = &h00080015
Const STATE_DUPLEX       = &h00180016
Const STATE_BROKEN       = &h00200003
Const STATE_UNKNOWN      = &h00FFFFFF


'====================================================================
' Tu[`
'====================================================================

'--------------------------------------------------------------------
' [֐] Ot@C̏o
'--------------------------------------------------------------------
Dim LogFolder, LogFilePath, LogHead
LogFolder = "C:\Program Files\NEC\HAS_SW\LOG\Tools"
LogFilePath = LogFolder & "\SraBidActionTool.log"

Dim objFS
Set objFS = WScript.CreateObject("Scripting.FileSystemObject")

If objFS.FolderExists(LogFolder) = False Then
  objFS.CreateFolder(LogFolder)
End If

Dim objShell
Set objShell = CreateObject("Wscript.Shell")

Function OutLog(ByVal strLog)
  Dim objFile
  Set objFile = objFS.OpenTextFile(Replace(LogFilePath, """", ""), 8, True)
  LogHead = "[" & Date & " " & Time & "] "
  objFile.WriteLine (LogHead & strLog)
  objFile.Close
End Function


'--------------------------------------------------------------------
' [֐] 񃌃x̃CxgO̓o^iCxgIDAbZ[Wj
'--------------------------------------------------------------------
Function RecordEventI(ByVal EventID, ByVal strMessage)
    Dim command
    command = "eventcreate /ID " & EventID & " /L System /T Information /SO SraBidAction /D """ & strMessage & """"
    objShell.Run command, 0, True
End Function


'--------------------------------------------------------------------
' [֐] xx̃CxgO̓o^iCxgIDAbZ[Wj
'--------------------------------------------------------------------
Function RecordEventW(ByVal EventID, ByVal strMessage)
    Dim command
    command = "eventcreate /ID " & EventID & " /L System /T Warning /SO SraBidAction /D """ & strMessage & """"
    objShell.Run command, 0, True
End Function


'--------------------------------------------------------------------
' [֐] G[x̃CxgO̓o^iCxgIDAbZ[Wj
'--------------------------------------------------------------------
Function RecordEventE(ByVal EventID, ByVal strMessage)
    Dim command
    command = "eventcreate /ID " & EventID & " /L System /T Error /SO SraBidAction /D """ & strMessage & """"
    objShell.Run command, 0, True
End Function


'--------------------------------------------------------------------
' [֐] rb.txt̍폜
'--------------------------------------------------------------------
Function DeleteRbTxt()
  Dim fso, command, DeleteFilePath

  ' t@CVXeIuWFNgƃVFIuWFNg̍쐬
  Set fso = CreateObject("Scripting.FileSystemObject")

  ' JgfBNgXNvg̎stH_ɐݒ
  objShell.CurrentDirectory = scriptFolder

  ' 폜t@C̃pXݒ
  DeleteFilePath = scriptFolder & "rb.txt"
  
  ' rb.txt݂ꍇ͍폜
  If fso.FileExists(DeleteFilePath) Then
    ' rb.txtꍇ
    
    fso.DeleteFile(DeleteFilePath)
    ' Call OutLog("[I] " & DeleteFilePath & "폜܂B" )
    
    Wscript.Sleep 5000
    
    ' rb.txt폜Ă邩̊mF
    If fso.FileExists(DeleteFilePath) Then
      Call OutLog("[E] " & DeleteFilePath & "̍폜Ɏs܂B" )
      Call RecordEventE(300, "Failed to delete rb.txt.")
      Free()
      Wscript.Quit(-1)
    
    Else
      ' Call OutLog("[I] " & DeleteFilePath & "̍폜܂B" )
    
    End If
    
  Else
    ' rb.txtȂꍇ
    ' Call OutLog("[I] " & DeleteFilePath & "܂B" )
    
  End If

End Function


'--------------------------------------------------------------------
' [֐] rb.txt̍쐬
'--------------------------------------------------------------------
Function CreateRbTxt()
  Dim fso, command, CreateFilePath

  ' t@CVXeIuWFNgƃVFIuWFNg̍쐬
  Set fso = CreateObject("Scripting.FileSystemObject")

  ' JgfBNgXNvg̎stH_ɐݒ
  objShell.CurrentDirectory = scriptFolder

  ' 쐬t@C̃pXݒ
  CreateFilePath = scriptFolder & "rb.txt"
  
  ' rb.txt쐬
  command = """C:\Program Files\ftsys\CustomerService\SupportTools\dbg.exe"" -c ""rb copy"""
  objShell.Run command, 0, False

  Wscript.Sleep 5000

  ' rb.txt쐬Ă邩̊mF
  If fso.FileExists(CreateFilePath) Then
    ' Call OutLog("[I] " & CreateFilePath & "̍쐬܂B" )
  Else
    Call OutLog("[E] " & CreateFilePath & "̍쐬Ɏs܂B" )
    Call RecordEventE(300, "Failed to create rb.txt.")
    Free()
    Wscript.Quit(-1)
  End If

End Function


'--------------------------------------------------------------------
' [֐] DDNS̔̊mF
'--------------------------------------------------------------------
Function CheckDdnsFromLog()

  Dim fso, ReadFilePath, strSearch, fileStream, line

  ' t@CVXeIuWFNgƃVFIuWFNg̍쐬
  Set fso = CreateObject("Scripting.FileSystemObject")

  ' ǂݍރt@C̃pXݒ
  ReadFilePath = scriptFolder & "rb.txt"

  ' 镶̎w
  strSearch = "NOT breaking PCI Board - driver did not start"
  
  CheckDdnsFromLog = 0 'DDNSołȂꍇ̖߂l

  ' rb.txtt@C݂邩mF
  If fso.FileExists(ReadFilePath) Then
      ' t@CJ
      Set fileStream = fso.OpenTextFile(ReadFilePath, 1, False) ' 1=ForReading
      
      ' t@C̊es`FbN
      Do Until fileStream.AtEndOfStream
          line = fileStream.ReadLine
          
          ' 񂪍sɊ܂܂Ă邩`FbN
          If InStr(line, strSearch) > 0 Then
              ' ȍił̓bZ[W{bNX\j
           
              If InStr(line, "PDOf 10/") > 0 Then
                  ' DDNSs "PDOf 10/" ܂܂ꍇ
                  CheckDdnsFromLog = 10
                  
              ElseIf InStr(line, "PDOf 11/") > 0 Then
                  ' DDNSs "PDOf 11/" ܂܂ꍇ
                  CheckDdnsFromLog = 11

              Else
                  ' DDNSĂ郂W[łȂꍇ
                  CheckDdnsFromLog = -1
                  
              End If

              Exit Do ' ړI̕o烋[vI
          End If
      Loop
            
      ' t@CXg[
      fileStream.Close
  Else
      ' rb.txt Ȃꍇ
      CheckDdnsFromLog = -2

  End If

  ' IuWFNg̊J
  Set fileStream = Nothing
  Set fso = Nothing

End Function


'--------------------------------------------------------------------
' [֐] WS2022̔
'--------------------------------------------------------------------
Function IsWS2022()
  Dim colOperatingSystems
  Dim objOperatingSystem
  Dim osVersion
  Set colOperatingSystems = objWbem.ExecQuery("Select * from Win32_OperatingSystem")

  For Each objOperatingSystem in colOperatingSystems
      osVersion = objOperatingSystem.Version
      If InStr(osVersion, "10.0") > 0 And objOperatingSystem.ProductType = 3 Then
          Dim caption
          caption = objOperatingSystem.Caption
          If InStr(caption, "2022") > 0 Then
              IsWS2022 = True 'WS2022
          Else
              IsWS2022 = False 'Windows 10, WS2016,  WS2019 ̂ꂩ
          End If
      Else
          IsWS2022 = False 'LȊO
      End If
  Next

End Function

'--------------------------------------------------------------------
' [֐] vC}̔ (WMIIuWFNgANXAfoCXID)
'--------------------------------------------------------------------
Function IsPrimary(ByRef WmiObj, ByVal ClassName, ByVal DevID)
  Dim DevObj
  Dim CmdStr

  CmdStr = ClassName & ".InstanceName=""" & DevID & """"

  Err.Clear
  Set DevObj = WmiObj.Get(CmdStr)
  If Err.Number <> 0 Then
    Call OutLog("[E] vC}̎擾Ɏs : " & Err.Source & " : " & Err.Description & "(0x" & Hex(Err.Number) & ")")
    IsPrimary = STATE_UNKNOWN
  Else
    If IsNull(DevObj.ActiveCompatibilityFlag) = True Then
      Call OutLog("[E] Ԃ̎擾Ɏs(ԂNull)")
      IsPrimary = STATE_UNKNOWN
    Else
      IsPrimary = DevObj.ActiveCompatibilityFlag
    End If
  End If
  
  Set DevObj = Nothing
  Set CmdStr = Nothing
End Function


'--------------------------------------------------------------------
' [֐] Ԃ擾 (WMIIuWFNgANXAfoCXID)
'--------------------------------------------------------------------
Function GetState(ByRef WmiObj, ByVal ClassName, ByVal DevID)
  Dim DevObj
  Dim CmdStr

  CmdStr = ClassName & ".InstanceName=""" & DevID & """"
  ' Call OutLog("[I] CmdStr=" & CmdStr)

  Err.Clear
  Set DevObj = WmiObj.Get(CmdStr)
  If Err.Number <> 0 Then
    Call OutLog("[E] Ԃ̎擾Ɏs : " & Err.Source & " : " & Err.Description & "(0x" & Hex(Err.Number) & ")")
    GetState = STATE_UNKNOWN
  Else
    If IsNull(DevObj.OperationalState.State) = True Then
      Call OutLog("[E] Ԃ̎擾Ɏs(ԂNull)")
      GetState = STATE_UNKNOWN
    Else
      GetState = DevObj.OperationalState.State
    End If
  End If
  
  Set DevObj = Nothing
  Set CmdStr = Nothing
End Function


'--------------------------------------------------------------------
' [֐] vC}̑҂킹 (NXAfoCXIDAԎ擾̊ԊuAJԂ̍ő)
'--------------------------------------------------------------------
Function WaitingPrimary(ByVal ClassName, ByVal DevID, ByVal Interval, ByVal MaxCount)
  Dim CurrentFlag
  Dim CurrentCount
    
  CurrentFlag = IsPrimary(objWbem, IOBoard_CLASS, DevID)
  CurrentCount = 0

  Do While CurrentFlag <> True
      CurrentCount = CurrentCount + 1
      If MaxCount <= CurrentCount Then
        Call OutLog("[E] DevID:" & DevID &"̃vC}̑҂킹Ń^CAEg(CurrentFlag=" & CurrentFlag  & ")")
        Call RecordEventE(300, "Timed out while waiting for the primary of DevID:" & DevID & ".")
        Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
        Free()
        Wscript.Quit(-1)
      End If
            
      ' Call OutLog("[I] DevID:" & DevID &"̃vC}̑҂킹(CurrentFlag=" & CurrentFlag & ")")
      WScript.Sleep Interval
      CurrentFlag = IsPrimary(objWbem, IOBoard_CLASS, DevID)
  Loop
  
  Call OutLog("[I] DevID:" & DevID &"̃vC}̑҂킹")

  Set CurrentFlag = Nothing
  Set CurrentCount = Nothing
End Function


'--------------------------------------------------------------------
' [֐] Ԃ̑҂킹 (NXAfoCXIDAړȈԁAԎ擾̊ԊuAJԂ̍ő)
'--------------------------------------------------------------------
Function WaitingState(ByVal ClassName, ByVal DevID, ByVal TargetState, ByVal Interval, ByVal MaxCount)
  CurrentState = GetState(objWbem, ClassName, DevID)
  CurrentCount = 0

  Do While CurrentState <> TargetState
      CurrentCount = CurrentCount + 1
      If MaxCount <= CurrentCount Then
        Call OutLog("[E] DevID:" & DevID &"̏Ԃ̑҂킹Ń^CAEg(CurrentState=" & CurrentState  & ", TargetState=" & TargetState & ")")
        Call RecordEventE(300, "Timed out while waiting for the status of DevID:" & DevID & ".")
        Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
        Free()
        Wscript.Quit(-1)
      End If
            
      ' Call OutLog("[I] DevID:" & DevID &"̏Ԃ̑҂킹(CurrentState=" & CurrentState  & ", TargetState=" & TargetState & ")")
      WScript.Sleep Interval
      CurrentState = GetState(objWbem, ClassName, DevID)
  Loop
  
  Call OutLog("[I] DevID:" & DevID &"̏Ԃ̑҂킹")
End Function


'--------------------------------------------------------------------
' [֐] d̑҂킹 (NXAPڂ̃foCXIDAQڂ̃foCXIDAԎ擾̊ԊuAJԂ̍ő)
'--------------------------------------------------------------------
Function WaitingDuplex(ByVal ClassName, ByVal DevID_1st, ByVal DevID_2nd, ByVal Interval, ByVal MaxCount)
  Dim CurrentState_1st
  Dim CurrentState_2nd
  Dim CurrentCount
  
  CurrentState_1st = GetState(objWbem, ClassName, DevID_1st)
  CurrentState_2nd = GetState(objWbem, ClassName, DevID_2nd)

  CurrentCount = 0

  Do While CurrentState_1st <> STATE_DUPLEX OR CurrentState_2nd <> STATE_DUPLEX
      CurrentCount = CurrentCount + 1
      If MaxCount <= CurrentCount Then
        Call OutLog("[E] dԂ̑҂킹Ń^CAEg(DevID:" & DevID_1st & "̏Ԃ" & CurrentState_1st  & ", DevID:" & DevID_2nd & "̏Ԃ" & CurrentState_2nd & ")")
        Call RecordEventE(300, "Timed out while waiting for DUPLEX on both CRUs.")
        Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
        Free()
        Wscript.Quit(-1)
      End If
            
      ' Call OutLog("[I] dԂ̑҂킹(DevID:" & DevID_1st & "̏Ԃ" & CurrentState_1st  & ", DevID:" & DevID_2nd & "̏Ԃ" & CurrentState_2nd & ")")
      WScript.Sleep Interval
      CurrentState_1st = GetState(objWbem, ClassName, DevID_1st)
      CurrentState_2nd = GetState(objWbem, ClassName, DevID_2nd)
  Loop
  
  Call OutLog("[I] dԂ̑҂킹")

  Set CurrentState_1st = Nothing
  Set CurrentState_2nd = Nothing
  Set CurrentCount = Nothing
End Function


'--------------------------------------------------------------------
' [֐] W[̑ (R}h^CvAfoCXID)
'--------------------------------------------------------------------
Function IoOperate(ByVal CmdType, ByVal DevID)
  Dim objBoard
  Dim CmdStr
  
  CmdStr = "SRA_IOBoard.InstanceName=""" & DevID & """"

  Err.Clear
  Set objBoard = objWbem.Get(CmdStr)
  If Err.Number <> 0 Then
    Call OutLog("[E] GetError " & CmdStr & ", error number = 0x" & Hex(Err.Number))
    Call RecordEventE(300, "GetError " & CmdStr)
    Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
    Free()
    Wscript.Quit(-1)
  End If
  
  Ret=0
  Err.Clear
  Select Case CmdType
    Case "Break"
      Call OutLog("[I] DevID:" & DevID & "̐؂藣Jn")
      Call objBoard.BreakBoard(Ret)
      
    Case "BringUp"
      Call OutLog("[I] DevID:" & DevID & "̋NJn")
      Call objBoard.InitiateBringUp(Ret)
      
    Case "BringDown"
      Call OutLog("[I] DevID:" & DevID & "̒~Jn")
      Call objBoard.InitiateBringDown(Ret)
      
    Case "ClearMtbf"
      Call OutLog("[I] DevID:" & DevID & "MTBFNA")
      Call objBoard.ClearMtbf(0, Ret) 'ftSW  7.x ȏ̏ꍇ
      
    Case "Active"
      Call OutLog("[I] DevID:" & DevID & "vC}ɐ؂ւJn")
      Call objBoard.MakeActiveCompat(Ret)
      
  End Select

  If Err.Number <> 0 Then
    Call OutLog("[E] R}h̎sɎs : " & CmdStr & ", error number = 0x" & Hex(Err.Number))
    Call RecordEventE(300, "Failed to execute the command : " & CmdStr)
    Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
    Free()
    Wscript.Quit(-1)
  End If

  If Ret <> 0 Then
    Call OutLog("[E] R}h̎sɎs : " & CmdStr & ", Ret = " & Ret)
    Call RecordEventE(300, "Failed to execute the command : " & CmdStr)
    Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
    Free()
    Wscript.Quit(-1)
  End If

  Wscript.Sleep 5000

  Set objBoard = Nothing
  Set CmdStr   = Nothing
End Function


'--------------------------------------------------------------------
' [֐] CrashDumpEnabledWXg̎擾
'--------------------------------------------------------------------
Function GetDumpReg(ByRef RegValue)
  Err.Clear
  RegValue = objShell.RegRead("HKLM\SYSTEM\CurrentControlSet\Control\CrashControl\CrashDumpEnabled")
  If Err.Number <> 0 Then
    Call OutLog("[E] CrashDumpEnabledWXg̎擾Ɏs")
    RegValue=-1
  Else
    Call OutLog("[I] CrashDumpEnabledWXg̎擾(l:" & RegValue & ")")
  End If
End Function


'--------------------------------------------------------------------
' [֐] CrashDumpEnabledWXg̐ݒ
'--------------------------------------------------------------------
Function SetDumpReg(ByRef RegValue)
  Err.Clear
  objShell.RegWrite "HKLM\SYSTEM\CurrentControlSet\Control\CrashControl\CrashDumpEnabled", RegValue, "REG_DWORD"
  If Err.Number <> 0 Then
    Call OutLog("[E] CrashDumpEnabledWXg̐ݒɎs")
    RegValue=-1
  Else
    Call OutLog("[I] CrashDumpEnabledWXg̐ݒ肪(l:" & RegValue & ")")
  End If
End Function


'--------------------------------------------------------------------
' ϐ
'--------------------------------------------------------------------
Sub Free()
  Set WS2022Flag      = Nothing
  Set SwitchFlag      = Nothing
  Set RegCrashDump    = Nothing
  Set IO10_State      = Nothing
  Set IO11_State      = Nothing
  Set CurrentState    = Nothing
  Set CurrentCount    = Nothing
  Set scriptPath      = Nothing
  Set scriptFolder    = Nothing
  Set LogFilePath     = Nothing
  Set LogFolder       = Nothing
  Set LogHead         = Nothing
  Set Ret             = Nothing
  Set objFS           = Nothing
  Set objShell        = Nothing
  Set objWbem         = Nothing
End Sub


'====================================================================
' C[`
'====================================================================

Call OutLog("[I] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̊Jn **********")


'--------------------------------------------------------------------
' OSJn̑҂킹
'--------------------------------------------------------------------

Wscript.Sleep WAIT_OS_START


'--------------------------------------------------------------------
' WMIIuWFNg̎擾
'--------------------------------------------------------------------
' Call OutLog("[I] ***** WMIIuWFNg̎擾 *****")
Err.Clear
Set objWbem = GetObject("winmgmts:{impersonationLevel=impersonate}!root/cimv2")
If Err.Number <> 0 Then
  Call OutLog("[E] WMIIuWFNg̎擾Ɏs : " & Err.Source & " : " & Err.Description & "(0x" & Hex(Err.Number) & ")")
  Call RecordEventE(300, "Failed to retrieve WMI object.")
  Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
  Call Free()
  Wscript.Quit(-1)
Else
  ' Call OutLog("[I] WMIIuWFNg̎擾")
End If


'--------------------------------------------------------------------
' Ot@Čƕ
'--------------------------------------------------------------------

' rb.txt̍폜
Call DeleteRbTxt()

' rb.txt̍쐬
Call CreateRbTxt()

' rb.txť
Ret = CheckDdnsFromLog()

If Ret = 0 Then
  Call OutLog("[I] DDNSo܂łB")
  Call RecordEventI(100, "No driver issues were detected.")


ElseIf Ret = 10 Then
  ' PCIW[#10DDNSȍ

  Call OutLog("[W] PCIW[#10DDNSo܂BJn܂B")
  Call RecordEventW(200, "Detected driver issues in PCI module 10. Starting recovery process.")

  ' ----- ̏Ԃ̑҂킹() -----
  CurrentState = GetState(objWbem, IOBoard_CLASS, IO10_DevID)
  CurrentCount = 0

  Do While CurrentState <> STATE_DUPLEX
      CurrentCount = CurrentCount + 1
      If 60 <= CurrentCount Then
        Call OutLog("[E] DevID:" & IO10_DevID &"̏Ԃ̑҂킹Ń^CAEg(CurrentState=" & CurrentState  & ", TargetState=" & STATE_DUPLEX & ")")
        Call RecordEventE(300, "Timed out while waiting for the status of DevID:" & IO10_DevID & ".")
        Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
        Free()
        Wscript.Quit(-1)
      End If
            
      ' Call OutLog("[I] DevID:" & IO10_DevID &"̏Ԃ̑҂킹(CurrentState=" & CurrentState  & ", TargetState=" & STATE_DUPLEX & ")")
      WScript.Sleep 10000
      CurrentState = GetState(objWbem, IOBoard_CLASS, IO10_DevID)
  Loop
  
  Call OutLog("[I] DevID:" & IO10_DevID &"̏Ԃ̑҂킹")
  ' ----- ̏Ԃ̑҂킹(܂) -----

  ' OSWS2022ł邩
  WS2022Flag = IsWS2022()

  If WS2022Flag = True Then
    Call GetDumpReg(RegCrashDump)
  End If
  Ret = IsPrimary(objWbem, IOBoard_CLASS, IO11_DevID)
  If Ret = False Then
    SwitchFlag = True
    Call IoOperate("Active", IO11_DevID)
    Call WaitingPrimary(IOBoard_CLASS, IO11_DevID, 5000, 30)
  End If
  Call IoOperate("BringDown", IO10_DevID)
  Call WaitingState(IOBoard_CLASS, IO10_DevID, STATE_REMOVED, 5000, 30)
  If WS2022Flag = True AND RegCrashDump <> 0 Then
    Call SetDumpReg(RegCrashDump)
  End If
  Call IoOperate("BringUp", IO10_DevID)
  Call WaitingDuplex(IOBoard_CLASS, IO10_DevID, IO11_DevID, 10000, 60)
  Ret = IsPrimary(objWbem, IOBoard_CLASS, IO10_DevID)
  If Ret = False AND SwitchFlag = True Then
    Call IoOperate("Active", IO10_DevID)
    Call WaitingPrimary(IOBoard_CLASS, IO10_DevID, 5000, 30)
    If WS2022Flag = True AND RegCrashDump <> 0 Then
      Call SetDumpReg(RegCrashDump)
    End If
  End If

  Call OutLog("[I] PCIW[#10̕܂B")
  Call RecordEventI(101, "Recovery process for PCI module 10 has been completed.")


ElseIf Ret = 11 Then
  ' PCIW[#11DDNSȍ

  Call OutLog("[W] PCIW[#11DDNSo܂BJn܂B")
  Call RecordEventW(200, "Detected driver issues in PCI module 11. Starting recovery process.")
  
  ' ----- ̏Ԃ̑҂킹() -----
  CurrentState = GetState(objWbem, IOBoard_CLASS, IO11_DevID)
  CurrentCount = 0

  Do While CurrentState <> STATE_DUPLEX
      CurrentCount = CurrentCount + 1
      If 60 <= CurrentCount Then
        Call OutLog("[E] DevID:" & IO11_DevID &"̏Ԃ̑҂킹Ń^CAEg(CurrentState=" & CurrentState  & ", TargetState=" & STATE_DUPLEX & ")")
        Call RecordEventE(300, "Timed out while waiting for the status of DevID:" & IO11_DevID & ".")
        Call OutLog("[E] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")
        Free()
        Wscript.Quit(-1)
      End If
            
      ' Call OutLog("[I] DevID:" & IO11_DevID &"̏Ԃ̑҂킹(CurrentState=" & CurrentState  & ", TargetState=" & STATE_DUPLEX & ")")
      WScript.Sleep 10000
      CurrentState = GetState(objWbem, IOBoard_CLASS, IO11_DevID)
  Loop
  
  Call OutLog("[I] DevID:" & IO11_DevID &"̏Ԃ̑҂킹")
  ' ----- ̏Ԃ̑҂킹(܂) -----
  
  ' OSWS2022ł邩
  WS2022Flag = IsWS2022()

  If WS2022Flag = True Then
    Call GetDumpReg(RegCrashDump)
  End If
  Ret = IsPrimary(objWbem, IOBoard_CLASS, IO10_DevID)
  If Ret = False Then
    SwitchFlag = True
    Call IoOperate("Active", IO10_DevID)
    Call WaitingPrimary(IOBoard_CLASS, IO10_DevID, 5000, 30)
  End If
  Call IoOperate("BringDown", IO11_DevID)
  Call WaitingState(IOBoard_CLASS, IO11_DevID, STATE_REMOVED, 5000, 30)
  If WS2022Flag = True AND RegCrashDump <> 0 Then
    Call SetDumpReg(RegCrashDump)
  End If
  Call IoOperate("BringUp", IO11_DevID)
  Call WaitingDuplex(IOBoard_CLASS, IO10_DevID, IO11_DevID, 10000, 60)
  Ret = IsPrimary(objWbem, IOBoard_CLASS, IO11_DevID)
  If Ret = False AND SwitchFlag = True Then
    Call IoOperate("Active", IO11_DevID)
    Call WaitingPrimary(IOBoard_CLASS, IO11_DevID, 5000, 30)
    If WS2022Flag = True AND RegCrashDump <> 0 Then
      Call SetDumpReg(RegCrashDump)
    End If
  End If
  
  Call OutLog("[I] PCIW[#11̕܂B")
  Call RecordEventI(101, "Recovery process for PCI module 11 has been completed.")


ElseIf Ret = -1 Then
  Call OutLog("[E] DDNSĂPCIW[ł܂łB")
  Call RecordEventE(300, "Could not identify the PCI module with driver issues.")

ElseIf Ret = -2 Then
  Call OutLog("[E] ɕKvȃt@C܂B")
  Call RecordEventE(300, "Files necessary for the investigation not found.")

Else
  Call OutLog("[E] \Ȃُ킪܂B")
  Call RecordEventE(300, "An unexpected error has occurred.")

End If

' rb.txt̍폜
Call DeleteRbTxt()

Call OutLog("[I] ********** " & SCRIPT_NAME  & " (ver" & VERSION & ") ̏I **********")


'--------------------------------------------------------------------
' I
'--------------------------------------------------------------------

Call Free()
Wscript.Quit(0)
